local AceConfig = LibStub("AceConfig-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("FailBotPro")
FailBotPro = CreateFrame("Frame")
local addon = FailBotPro
LibStub("AceConsole-3.0"):Embed(addon)
LibStub("LibSimpleTimer-1.0"):Embed(addon)

local announce_to = {
	SAY = L["Say"],
	RAID = L["Raid"],
	GUILD = L["Guild"],
	PARTY = L["Party"],
	OFFICER = L["Officer"],
	CHANNEL = L["Channel"],
}

function FailBotPro:Initialize()
	if FailCount == nil then
		FailCount = {}
	elseif OFailCount == nil then
		OFailCount = {}
	end
end	

function FailBotPro:MenuButtonRemove(info, input)
	if self.db.profile.announce == "CHANNEL" then
		whisper=self.db.profile.channelnumber
		target=self.db.profile.announce
	else
		target=self.db.profile.announce
	end
	local firstletter = string.upper(string.sub(input,0,1))
	local rest = string.sub(input,2)
	local p = firstletter..rest		
	FailBotPro:RemoveFail(p,target,whisper)
end

function FailBotPro:OpenMenu(input)
	if input == "" then InterfaceOptionsFrame_OpenToCategory("FailBotPro")
	elseif input == "wipe" then
		FailBotPro:Wipe()
	elseif input=="reset" then
		FailBotPro:reset()
	elseif input=="oreset" then
		FailBotPro:oreset()
	elseif (string.sub(input,0,6)=="remove") then
		if self.db.profile.announce == "CHANNEL" then
			whisper=self.db.profile.channelnumber
			target=self.db.profile.announce
		else
			target=self.db.profile.announce
		end
		if (string.len(input) > 6) then
			local name = string.sub(input,8)
			local firstletter = string.upper(string.sub(name,0,1))
			local rest = string.sub(name,2)
			local p = firstletter..rest		
			FailBotPro:RemoveFail(p,target,whisper)
		end
	end
end

function FailBotPro:SetChannelNumber(info, input)
	self.db.profile.channelnumber = GetChannelName(input)
end

function FailBotPro:GetChannelNumber(input)
	return self.db.profile.channelnumber
end

FailBotPro:SetScript("OnEvent", function(self, event, ...)
	if event == "ADDON_LOADED" and arg1 == "FailBotPro" then
		FailBotPro:Initialize()		
		self.db = LibStub("AceDB-3.0"):New("FailBotProDB", {
			profile = {
				bombbots = false,
				mines = false,
				cold = false,		
				resetoncombat = false,
				announce = "RAID",
			},
		}, "Default")
		
		local args = {
			type = "group",
			handler = self,
			get = function(info) return self.db.profile[info[1]] end,
			set = function(info, v) self.db.profile[info[1]] = v end,
			args = {			
				desc = {
					type = "description",
					name = L["addon_desc"],
					order = 1,
					fontSize = "medium",
				},
				filter_header = {
					type = "header",
					name = L["filter"],
					order = 2,
				},
				bombbots = {
					type = "toggle",
					name = L["bombbots"],
					desc = L["bombbots_desc"],
					order = 3,
				},
				mines = {
					type = "toggle",
					name = L["mines"],
					desc = L["mines_desc"],
					order = 4,
				},
				cold = {
					type = "toggle",
					name = L["cold"],
					desc = L["cold_desc"],
					order = 5,
				},
				lightbomb = {
					type = "toggle",
					name = L["lightbomb"],
					desc = L["lightbomb_desc"],
					order = 6,
				},
				reset_header = {
					type = "header",
					name = L["reset"],
					order = 10,
				},
				resetoncombat = {
					type = "toggle",
					name = L["reset on combat"],
					order = 80,
				},	
				reset = {
					order = 90,
					type = "execute",
					name = L["reset"],
					desc = L["reset_desc"],
					func = function()
						FailBotPro:reset()
					end
				},
				oreset = {
					order = 90,
					type = "execute",
					name = L["oreset"],
					desc = L["oreset_desc"],
					func = function()
						FailBotPro:oreset()
					end
				},
				announce_header = {
					type = "header",
					name = L["announce"],
					order = 100,
				},
				announce = {
					order = 210,
					type = "select",
					name = L["announce"],
					desc = L["announce_desc"],
					values = announce_to,
				},
				channel = {
					order = 210,
					type = "input",
					name = L["Channel"],
					desc = L["Channel"],
					set = "SetChannelNumber",
					get = "GetChannelNumber",
				},
				newline = {
					type = "description",
					name = "\n",
					order = 211,				
				},
				stats = {
					order = 214,
					type = "execute",
					name = L["stats"],
					desc = L["stats_desc"],
					func = function()
						FailBotPro:Stats(addon.db.profile.announce,"stats",addon.db.profile.channelnumber)
					end
				},
				ostats = {
					order = 218,
					type = "execute",
					name = L["ostats"],
					desc = L["ostats_desc"],
					func = function()
						FailBotPro:Stats(addon.db.profile.announce,"ostats",addon.db.profile.channelnumber)
					end
				},
				remove_header = {
					type = "header",
					name = L["remove"],
					order = 220,
				},
				menubuttonremove = {
					order = 330,
					type = "input",
					name = L["remove"],
					desc = L["remove_desc"],
					set = "MenuButtonRemove",
				},
			},
		}

		LibStub("AceConfig-3.0"):RegisterOptionsTable("FailBotPro", args)
		LibStub("AceConfigDialog-3.0"):AddToBlizOptions("FailBotPro", "FailBotPro")
		self:RegisterChatCommand("fbp", "OpenMenu")
		self:RegisterChatCommand("FailBotPro", "OpenMenu")
	elseif event == "COMBAT_LOG_EVENT_UNFILTERED" then
		FailBotPro:CombatLog(event,...)
	elseif (event=="PLAYER_REGEN_DISABLED") then -- entering combat
		if addon.db.profile.resetoncombat then
			FailCount = {}
		end
	elseif event == "CHAT_MSG_RAID_LEADER" or "CHAT_MSG_RAID" or "CHAT_MSG_PARTY" or "CHAT_MSG_SAY" or "CHAT_MSG_GUILD" or "CHAT_MSG_CHANNEL" then
		local msg,_,_,_,_,_,_,channelnum = select(1,...)
		msg = string.lower(msg)
		if event == "CHAT_MSG_RAID_LEADER" then
			if msg:find("!wipe") then
				FailBotPro:Wipe()
			end
		elseif event == "CHAT_MSG_RAID" then
			if msg:find("!wipe") then
				FailBotPro:Wipe()
			end
		end
		if msg:find("!stats") then
			target = string.sub(event,10)
				if target == "RAID_LEADER" then
					target = "RAID"
				end
			FailBotPro:Stats(target,"stats",channelnum)
		elseif msg:find("!ostats") then
			target = string.sub(event,10)
				if target == "RAID_LEADER" then
					target = "RAID"
				end
			FailBotPro:Stats(target,"ostats",channelnum)
		end
	end
end)


addon:RegisterEvent("PLAYER_REGEN_DISABLED")
addon:RegisterEvent("ADDON_LOADED")
addon:RegisterEvent("CHAT_MSG_RAID")
addon:RegisterEvent("CHAT_MSG_RAID_LEADER")
addon:RegisterEvent("CHAT_MSG_PARTY")
addon:RegisterEvent("CHAT_MSG_SAY")
addon:RegisterEvent("CHAT_MSG_GUILD")
addon:RegisterEvent("CHAT_MSG_CHANNEL")
addon:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED", "CombatLog")


-- local variables --
local heal_amount = 0
local LastEvent1 = {}
local LastEvent2 = {}
local ChargeCounter = {}
local ThaddiusAlive = true;
local WightLastAction = 0

function FailBotPro:Stats(target, stat, whisper)
	if stat == "ostats" then
		Count = OFailCount
	else
		Count = FailCount
	end
	local count,players=0,0
	local sorttable={}
	for k,v in pairs(Count) do
		count = count + v
		players = players + 1
		table.insert(sorttable, {k,v})
	end
	if (players == 0) then
		SendChatMessage(L["nobody_failed"],target, nil, whisper)
	else
		table.sort(sorttable,function(a,b) return a[2] > b[2] end)
		SendChatMessage(L["we_have"]..count..L["fails_on"]..players..L["diff..."],target, nil, whisper)
		local b=1
		for k,v in ipairs(sorttable) do
			if (b <= 10) then
				if b == 1 then
					if stat == "ostats" then
						SendChatMessage(L["admiral"]..v[1]..L["failed"]..v[2].."x ("..string.format("%02.1f",v[2]/count*100).."%)",target, nil, whisper)
					else
						SendChatMessage(L["captain"]..v[1]..L["failed"]..v[2].."x ("..string.format("%02.1f",v[2]/count*100).."%)",target, nil, whisper)
					end
				else
					SendChatMessage(b..". "..v[1]..L["failed"]..v[2].."x ("..string.format("%02.1f",v[2]/count*100).."%)",target, nil, whisper)
					end
				end
				b=b+1
			end
			if (GetNumPartyMembers() > 0) or (GetNumRaidMembers() > 0) then
				local r,name={},""
				if (GetNumRaidMembers() > 0) then
					for i=1,GetNumRaidMembers() do
						name=GetRaidRosterInfo(i)
						if (Count[name] == nil) then
							table.insert(r,name)
						end
					end
				else
					for i=1,GetNumPartyMembers() do
						name = UnitName("party"..i)
						if (Count[name] == nil) then
							table.insert(r,name)
						end
					end
					name = UnitName("player")
					if (Count[name] == nil) then
						table.insert(r,name)
					end
				end
				SendChatMessage(L["didnt_fail"]..table.concat(r,", "),target, nil, whisper)
			end
		end	
end

function FailBotPro:GetSpellLocalizedName(spellId)
	fail_name = (" ("..GetSpellInfo(spellId)..")")
	return fail_name
end


function FailBotPro:CombatLog(event,...)
	local timestamp, type, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags = select(1,...)
		
	if (sourceName=="Mirror Image") or (destName=="Mirror Image") then
			return;
	end
--------------------------------------------------------------------------------
--------------------	DEBUG EVENTS	----------------------------------------
--------------------------------------------------------------------------------

	if (type=="SPELL_CAST_START") then
		local spellId = select(9,...)
		if (spellId==635) then
			FailBotPro:AddFail(sourceName,L["Holy Loght"]..FailBotPro:GetSpellLocalizedName(spellId))
		end
	end

	if (type=="SPELL_CAST_START") then
		local spellId = select(9,...)
		if ((spellId==49273) or (spellId==49276)) then
			FailBotPro:AddFail(sourceName,L["shaman_healing"],spellId)
		end
	end

	if (type=="SPELL_CAST_START") then
		local spellId = select(9,...)
		if (spellId==55459) then
			FailBotPro:AddFail(sourceName,L["moving"].."( "..L["Frost Bomb"]..")")
		end
	end

	if (type=="SPELL_DAMAGE") then
		local spellId = select(9,...)
		if (spellId=="Earth Shock") then
			if bit.band(destFlags, COMBATLOG_OBJECT_TYPE_PLAYER) > 0 then
				FailBotPro:AddFail(destName,"ETest")
			end
		end
	end

	if (type=="SPELL_DAMAGE") then
		local spellId = select(9,...)
		if (spellId=="Frost Shock") then
			if bit.band(destFlags, COMBATLOG_OBJECT_TYPE_PLAYER) > 0 then
				FailBotPro:AddFail(destName,"FTest")
			end
		end
	end

--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------

if (type=="SPELL_DAMAGE") then
	if bit.band(destFlags, COMBATLOG_OBJECT_TYPE_PLAYER) > 0 then
		local spellId,_,_,amount = select(9,...)
---- FLAME LEVIATHAN ----		
---- RAZORSCALE ----		
--4/28 19:52:13.198  SPELL_DAMAGE,0x0000000000000000,nil,0x80000000,0x05000000027ED384,"Shinen",0x514,64733,"Devouring Flame",0x4,9471,0,4,1002,0,0,nil,nil,nil			
-- Devouring Flame -- Razorscale
		if (spellId==64733) then			
			if UnitClass(destName) == L["Warrior"] then
				if UnitHealthMax(destname) <= 30000 then
					if LastEvent1[destName] == nil then
						LastEvent1[destName] = timestamp
						FailBotPro:AddFail(destName,L["moving"],spellId)
					else
						if (timestamp - LastEvent1[destName]) > 4 then
							FailBotPro:AddFail(destName,L["moving"],spellId)
						end
						LastEvent1[destName] = timestamp
					end
				end
			else 
				if LastEvent1[destName] == nil then
					LastEvent1[destName] = timestamp
					FailBotPro:AddFail(destName,L["moving"],spellId)
				else
					if (timestamp - LastEvent1[destName]) > 4 then
						FailBotPro:AddFail(destName,L["moving"],spellId)
					end
					LastEvent1[destName] = timestamp
				end
			end
---- XT-002 ----			
--5/7 18:19:04.078  SPELL_DAMAGE,0xF1300084D1002E23,"Void Zone",0xa48,0x0300000001D3239F,"Diomache",0x514,64208,"Consumption",0x20,6258,0,32,0,0,0,nil,nil,nil
-- Void Zone -- XT-002 ?			
		elseif ((spellId==64208) or (spellId==64206)) then
			FailBotPro:AddFail(destName,L["moving"],spellId)
---- THE IRON COUNCIL ----			
--3/20 19:22:43.389  SPELL_DAMAGE,0xF130008059000703,"Stormcaller Brundir",0x8000a48,0x01000000007C5537,"Vanen",0x512,61878,"Overload",0x8,17460,0,8,2000,0,0,nil,nil,nil
-- Overload -- The Iron Council - small guy			
		elseif (((spellId==61878) or (spellId==63480))and sourceName==L["Stormcaller Brundir"]) then
			if amount >= 5000 then
				FailBotPro:AddFail(destName,L["moving"],spellId)
			end	
---- KOLOGARN ----
-- Focused Eyebeam -- Kologarn
	elseif ((spellId==63976) or (spellId==63346)) then
		if LastEvent1[destName] == nil then
			LastEvent1[destName] = timestamp
			FailBotPro:AddFail(destName,L["moving"],spellId)
		else
			if (timestamp - LastEvent1[destName]) > 5 then
				FailBotPro:AddFail(destName,L["moving"],spellId)
			end
			LastEvent1[destName] = timestamp
		end
---- AUIRAYA ----
-- Seeping Feral Essence -- Auiraya			
		elseif ((spellId==64459) or (spellId==64675)) then
			if LastEvent1[destName] == nil then
				LastEvent1[destName] = timestamp
				FailBotPro:AddFail(destName,L["moving"],spellId)
			else
				if (timestamp - LastEvent1[destName]) > 4 then
					FailBotPro:AddFail(destName,L["moving"],spellId)
				end
				LastEvent1[destName] = timestamp
			end	
---- HODIR ----			
--4/24 13:23:54.093  SPELL_DAMAGE,0x0000000000000000,nil,0x80000000,0x0300000001D324FD,"Munken",0x512,62188,"Biting Cold",0x10,307,0,16,80,0,0,nil,nil,nil
-- Biting Cold -- Hodir	
		elseif ((spellId==62038) or (spellId==62188)) then
			if self.db.profile.cold then			
				cold = getCold(destName)
				if stack > 2 then
					FailBotPro:AddFail(destName,L["moving"],spellId)
				end
			end	
---- THORIM ----			
--4/16 18:20:24.295  SPELL_DAMAGE,0xF130008061018374,"Thorim",0x8010a48,0x0500000001E8AF39,"Thefeint",0x514,62466,"Lightning Charge",0x8,8977,0,8,3966,0,0,nil,nil,nil
-- Lightning Charge -- Thorim			
		elseif ((spellId==62466) and sourceName==L["Thorim"]) then
			FailBotPro:AddFail(destName,L["moving"],spellId)
--4/16 01:06:26.414  SPELL_DAMAGE,0x0000000000000000,nil,0x80000000,0x05000000027ECA9C,"Cn",0x514,62465,"Runic Smash",0x4,6544,0,4,3116,0,0,nil,nil,nil
-- Runic Smash -- Thorim tunnel ?			
		elseif (spellId==62465) then
			if LastEvent1[destName] == nil then
				LastEvent1[destName] = timestamp
				FailBotPro:AddFail(destName,L["left and right"])
			else
				if (timestamp - LastEvent1[destName]) > 4 then
					FailBotPro:AddFail(destName,L["left and right"])
				end
				LastEvent1[destName] = timestamp
			end		
---- FREYA ----
-- Unstable Energy -- Freya
		elseif (spellId==62865) then
			if LastEvent1[destName] == nil then
				LastEvent1[destName] = timestamp
				FailBotPro:AddFail(destName,L["moving"],spellId)
			else
				if (timestamp - LastEvent1[destName]) > 4 then
					FailBotPro:AddFail(destName,L["moving"],spellId)
				end
				LastEvent1[destName] = timestamp
			end	
---- MIMIRON ----			
-- Flames -- Mimiron			
		elseif (spellId==64566) then	
			if LastEvent1[destName] == nil then
				LastEvent1[destName] = timestamp
				FailBotPro:AddFail(destName,L["moving"],spellId)
			else
				if (timestamp - LastEvent1[destName]) > 4 then
					FailBotPro:AddFail(destName,L["moving"],spellId)
				end
				LastEvent1[destName] = timestamp
			end
--4/16 13:16:23.167  SPELL_DAMAGE,0xF13000863A00929D,"Proximity Mine",0xa48,0x05000000027ECCF4,"Hotalicious",0x512,63009,"Explosion",0x4,22500,16608,4,2500,0,0,nil,nil,nil
-- Proxmity Mine -- Mimiron			
		elseif ((spellId==63009) and (sourceName==L["Proximity Mine"])) then	
			if self.db.profile.mines then
				if LastEvent1[destName] == nil then
					LastEvent1[destName] = timestamp
					FailBotPro:AddFail(destName,L["moving"].." ("..L["Proximity Mine"]..")")
				else
					if (timestamp - LastEvent1[destName]) > 2 then
						FailBotPro:AddFail(destName,L["moving"].." ("..L["Proximity Mine"]..")")
					end
					LastEvent1[destName] = timestamp
				end	
			end
--4/16 18:50:56.578  SPELL_DAMAGE,0x0000000000000000,nil,0x80000000,0x05000000027ECB89,"Logicalness",0x514,64875,"Sapper Explosion",0x40,67542,45099,64,28421,0,0,nil,nil,nil
-- Sapper Explosion -- Mimiron Trash			
		elseif (spellId==64875) then
			FailBotPro:AddFail(destName,L["moving"],spellId)
--3/13 20:56:28.111  SPELL_DAMAGE,0xF1300084FF001E10,"Rocket Strike",0xa48,0x01000000007C088D,"Veev",0x511,63041,"Rocket Strike",0x4,676800,657890,4,200000,0,0,nil,nil,nil
-- Rocket Strike -- Mimiron
		elseif (spellId==63041) then 
			FailBotPro:AddFail(destName,L["moving"],spellId)
--3/13 21:05:11.205  SPELL_DAMAGE,0xF1500083730020DC,"VX-001",0x10a48,0x01000000007F4785,"Lawlpurge",0x514,63293,"P3Wx2 Laser Barrage",0x40,19400,1821,64,0,0,0,nil,nil,nil
-- Lasar Barrage -- Mimiron			
		elseif (spellId==63293) then
			if LastEvent1[destName] == nil then
				LastEvent1[destName] = timestamp
				FailBotPro:AddFail(destName,L["moving"],spellId)
			else
				if (timestamp - LastEvent1[destName]) > 3 then
					FailBotPro:AddFail(destName,L["moving"],spellId)
				end
				LastEvent1[destName] = timestamp
			end		
--3/13 21:17:23.756  SPELL_DAMAGE,0xF150008298002210,"Leviathan Mk II",0x10a48,0xF1300007AC0025A9,"Treant",0x1114,63631,"Shock Blast",0x8,97000,92908,8,0,0,0,nil,nil,nil
-- Shock Blast -- Mimiron			
		elseif (spellId==63631) then
			FailBotPro:AddFail(destName,L["moving"],spellId)
--4/25 12:58:04.640  SPELL_DAMAGE,0xF1300085650042DC,"Frost Bomb",0xa48,0x030000000106ED69,"Pachinko",0x514,65333,"Explosion",0x10,39839,35289,16,9960,0,0,nil,nil,nil	
-- Frost Bomb -- Mimiron			
		elseif (sourceName==L["Frost Bomb"]) and (spellId==65333)  then --or (spellId=64626))
			FailBotPro:AddFail(destName,L["moving"].."( "..L["Frost Bomb"]..")")
--4/16 13:35:12.750  SPELL_DAMAGE,0xF13000842C0094E3,"Bomb Bot",0xa48,0x05000000027ECCA5,"Naddia",0x512,63801,"Bomb Bot",0x4,20216,4025,4,5054,0,0,nil,nil,nil
-- Bomb Bot -- Inside Mimiron's room			
		elseif (spellId==63801) then
			if (GetMinimapZoneText()=="The Spark of Imagination") then			
				FailBotPro:AddFail(destName,L["moving"],spellId)
			end
---- GENERAL VEZAX ----	
--4/16 22:06:17.885  SPELL_DAMAGE,0xF1300081F702D928,"General Vezax",0x10a48,0x05000000027FCDFE,"Kosie",0x514,62659,"Shadow Crash",0x20,9413,0,32,2285,0,0,nil,nil,nil
-- Shadow Crash -- General Vezax			
		elseif ((spellId==63277) or (spellId==62659)) and sourceName==L["General Vezax"] then
			FailBotPro:AddFail(destName,L["moving"],spellId)		
--Line 435447 : 4/17 19:50:51.493  SPELL_DAMAGE,0x0000000000000000,nil,0x80000000,0x05000000027ECAFC,"Turyia",0x514,63884,"Death Ray",0x8,12800,3981,8,4000,0,0,nil,nil,nil		
-- Death Ray -- Yogg-Saron			
		elseif ((spellId==63891) or (spellId==63884)) then
			local malady = GetSpellInfo(63830)
			local debuff_name = UnitDebuff(destName, malady)
			if LastEvent1[destName] == nil then
				LastEvent1[destName] = timestamp
				if debuff_name ~= "Malady of the Mind" then		
					FailBotPro:AddFail(destName,L["moving"],spellId)
				end
			else
				if (timestamp - LastEvent1[destName]) > 3 then
					if debuff_name ~= "Malady of the Mind" then		
						FailBotPro:AddFail(destName,L["moving"],spellId)
					end
				end
				LastEvent1[destName] = timestamp
			end			
--5/5 17:23:21.435  SPELL_DAMAGE,0x0000000000000000,nil,0x80000000,0x0300000001B85A77,"Ragebar",0x512,62311,"Cosmic Smash",0x4,5262,0,4,0,0,0,nil,nil,nil
-- Cosmic Smash -- Algalon
		elseif ((spellId==62311) or (spellId==64596)) then
			if amount >= 5000 then
				FailBotPro:AddFail(destName,L["moving"],spellId)
			end
-- Big Bang -- Algalon			
		elseif ((spellId==64584) or (spellId==64443)) then
			if amount >= 75000 then
				FailBotPro:AddFail(destName,L["moving"],spellId)
			end		
		end
	end
end

---- XT-002 ----
-- Light Bomb -- XT-002
if self.db.profile.lightbomb then
	if (type=="SPELL_DAMAGE") then	
		local spellId = select(9,...)
		if bit.band(sourceFlags, COMBATLOG_OBJECT_TYPE_PLAYER) > 0 then
			if (spellId==65120) then
				if ChargeCounter[sourceName] == nil then
					ChargeCounter[sourceName] = 1
					LastEvent1[sourceName] = timestamp
				else
					if (timestamp - LastEvent1[sourceName]) > 5 then
						ChargeCounter[sourceName] = 1
					elseif (timestamp - LastEvent1[sourceName]) > 1 then
						ChargeCounter[sourceName] = ChargeCounter[sourceName] + 1
					end
					LastEvent1[sourceName] = timestamp
				end
				if ChargeCounter[sourceName] == 3 then
					FailBotPro:AddFail(sourceName,L["moving"],spellId)
					ChargeCounter[sourceName] = 0
				end
			end
		end
	end
end
-- Gravity Bomb -- XT-002
if (type=="SPELL_DAMAGE") then
	local spellId = select(9,...)
	if bit.band(sourceFlags, COMBATLOG_OBJECT_TYPE_PLAYER) > 0 then
		if (spellId==64233) then 
			if ChargeCounter[sourceName] == nil then
				ChargeCounter[sourceName] = 1
				LastEvent1[sourceName] = timestamp
			elseif (timestamp - LastEvent1[sourceName]) < 1 then
				ChargeCounter[sourceName] = ChargeCounter[sourceName] + 1
				LastEvent1[sourceName] = timestamp
			else
				ChargeCounter[sourceName] = 1
				LastEvent1[sourceName] = timestamp
			end
			if ChargeCounter[sourceName] == 2 then
				FailBotPro:AddFail(sourceName,L["moving"],spellId)
				ChargeCounter[sourceName] = 0
			end
		end
	end
end

if (type=="SPELL_ENERGIZE") then
	local spellId,_,_,amount = select(9,...)
	if bit.band(destFlags, COMBATLOG_OBJECT_TYPE_PLAYER) > 0 then
--4/29 22:38:40.135  SPELL_ENERGIZE,0x0000000000000000,nil,0x80000000,0x0500000002BFA226,"Cimsir",0x514,63337,"Saronite Vapors",0x20,12800,0
--4/29 22:38:40.135  SPELL_DAMAGE,0x0000000000000000,nil,0x80000000,0x0500000002BFA226,"Cimsir",0x514,63338,"Saronite Vapors",0x20,20480,8387,32,5120,0,0,nil,nil,nil
--	Saronite Vapors  -- General Vezax
		if (spellId==63337) then		
			if (amount == 12800) then
				FailBotPro:AddFail(destName,L["moving"],spellId)
			end
		end
	end
end

if (type=="SPELL_DISPEL") then
		local extraSpellId = select(12,...)
--4/16 16:22:38.229  SPELL_DISPEL,0x05000000027EF48C,"Veev",0x511,0xF13000824A00E5AD,"Corrupted Servitor",0x8010a48,47488,"Shield Slam",0x1,63559,"",8,BUFF
-- Bind Life -- Freya Trash		
		if (extraspellId==63559) then
			FailBotPro:AddFail(sourceName,L["not_dispelling"])
		end
end

if (type=="SPELL_INTERRUPT") then
	local spellId = select(9,...)
	if bit.band(destFlags, COMBATLOG_OBJECT_TYPE_PLAYER) > 0 then
		if UnitClass(destName) ~= L["Warlock"] then			
--3/16 19:50:05.275  SPELL_INTERRUPT,0x0000000000000000,nil,0x80000000,0x01000000007CED8E,"Mute",0x514,62681,"Flame Jets",0x4,49238,"Lightning Bolt",8
-- Flame Jets -- Ignis
			if (spellId==62681) then					
				FailBotPro:AddFail(destName,L["not_casting"],spellId)
-- Ground Tremor -- Freya and Elder							
			elseif ((spellId==62859) or (spellId==62437) or (spellId==62325) or (spellId==62932)) then
				FailBotPro:AddFail(destName,L["not_casting"],spellId)
			end
		end
	end
end

if (type=="SPELL_AURA_APPLIED") then
	local spellId = select(9,...)
---- HODIR ----
--2/26 20:15:03.498  SPELL_AURA_APPLIED,0x0000000000000000,nil,0x80000000,0x01000000007C66FF,"Museedad",0x4000514,61969,"Flash Freeze",0x10,DEBUFF
-- Flash Freez -- Hodir
--add a check for hodir's room name		
	if ((spellId==61969) or (spellId==61990)) then
		if bit.band(destFlags, COMBATLOG_OBJECT_TYPE_PLAYER) > 0 then
			if (GetMinimapZoneText()==L["The Halls of Winter"]) then -- makes sure not on yogg
				FailBotPro:AddFail(destName,L["moving"],spellId)
			end
		end		
---- YOGG-SARON ----			
--5/11 19:02:48.828  SPELL_AURA_APPLIED,0x0300000001D2A4D6,"Mackzter",0x8000514,0x0300000001D32634,"Aryu",0x514,63881,"Malady of the Mind",0x20,DEBUFF
-- Malady of the Mind -- Yogg-Saron		
	elseif (spellId==63881) then
		if bit.band(sourceFlags, COMBATLOG_OBJECT_TYPE_PLAYER) > 0 then
			FailBotPro:AddFail(destName,L["moving"],spellId)
		end
	end
end

---- GENERAL VEZAX ----	
if (type=="SPELL_HEAL") then
	local spellId,_,_,amount = select(9,...)
-- General healing himself	
	if spellId == 63278 then
		heal_amount = heal_amount + amount
	end
end

if (type=="SPELL_AURA_REMOVED") then
	local spellId = select(9,...)
-- Aura removed from the player
	if spellId == 63276 then
		if heal_amount > 350000 then
			heal_amount = 0
			FailBotPro:AddFail(destName,L["moving"],spellId)
		end
	end
end

-------------------------------------
------		NAXXRAMAS		---------
-------------------------------------

-- Mutating Injection -- Grobbolus --
if (type=="SPELL_DISPEL") then
	local extraSpellId = select(12,...)	
	if (extraspellId==28169) then
		FailBotPro:AddFail(sourceName,L["not_dispelling"])
	end
end

if (type=="SPELL_DAMAGE") then
	local spellId = select(9,...)
	if bit.band(destFlags, COMBATLOG_OBJECT_TYPE_PLAYER) > 0 then
-- Flame Tsunami -- Sartharion	
		if (spellId==57491) then			
			if LastEvent1[destName] == nil then
				LastEvent1[destName] = timestamp
				FailBotPro:AddFail(destName,L["moving"],spellId)
			else
				if (timestamp - LastEvent1[destName]) > 10 then
					FailBotPro:AddFail(destName,L["moving"],spellId)
				end
				LastEvent1[destName] = timestamp
			end	
-- Eruption -- Heigan		
		elseif (spellId==29371) then
			if LastEvent1[destName] == nil then
				LastEvent1[destName] = timestamp
				FailBotPro:AddFail(destName,L["moving"],spellId)
			else
				if (timestamp - LastEvent1[destName]) > 2 then
					FailBotPro:AddFail(destName,L["moving"],spellId)
				end
				LastEvent1[destName] = timestamp
			end
--12/30 19:46:34.741  SPELL_DAMAGE,0xF130003E9B0084A5,"Living Poison",0xa48,0x0000000001D2D545,"Meka",0x514,28433,"Explode",0x8,28376,11654,8,3153,0,0,nil,nil,nil
-- Frogger		
		elseif (spellId==28433) then
			FailBotPro:AddFail(destName,L["moving"],spellId)
-- Void Zones		
		elseif ((spellId==27812) or (spellId==57581) or (spellId==59128))  then
			FailBotPro:AddFail(destName,L["moving"],spellId)
-- Frost Breath -- Sapphiron		
		elseif (spellId==28524) then
			FailBotPro:AddFail(destName,L["moving"],spellId)
		end	
	end
end

if (type=="SPELL_CAST_START") then
	local spellId = select(9,...)
	if (spellId==28089) then
		ChargeCounter = {}
		ThaddiusAlive = true;
	end
end

if (type=="UNIT_DIED") then
	if (destName==L["Thaddius"]) then
		ThaddiusAlive = false;
	end
end

if (destName==L["Stalagg"]) or (destName==L["Feugen"]) then
		WightLastAction = timestamp
end

if (ThaddiusAlive) then
	if (type=="SPELL_DAMAGE") then
		local spellId = select(9,...)
		if bit.band(sourceFlags, COMBATLOG_OBJECT_TYPE_PLAYER) > 0 then
			if ((spellId==28062) or (spellId==28085)) then
				if ChargeCounter[sourceName] == nil then
					ChargeCounter[sourceName] = 1
					LastEvent1[sourceName] = timestamp
				elseif (timestamp - LastEvent1[sourceName]) < 2 then
					ChargeCounter[sourceName] = ChargeCounter[sourceName] + 1
					LastEvent1[sourceName] = timestamp
				else
					ChargeCounter[sourceName] = 1
					LastEvent1[sourceName] = timestamp
				end
				if ChargeCounter[sourceName] == 3 then
					FailBotPro:AddFail(sourceName,L["left and right"])
				end
			end
		end
	end
end

if (timestamp - WightLastAction) < 60 then
	if (type=="SPELL_AURA_APPLIED") then
		local spellId = select(9,...)
		if (spellId==28801) then
			if bit.band(destFlags, COMBATLOG_OBJECT_TYPE_PLAYER) > 0 then
				WightLastAction = timestamp
				if LastEvent2[destName] == nil then
					FailBotPro:AddFail(destName,L["jumping"])
				elseif (timestamp - LastEvent2[destName]) > 5 then
					FailBotPro:AddFail(destName,L["jumping"])
				end
			end
		end
	elseif (type=="SPELL_AURA_REMOVED") then
		local spellId = select(9,...)
		if (spellId==28801) then
			if bit.band(destFlags, COMBATLOG_OBJECT_TYPE_PLAYER) > 0 then
				LastEvent2[destName] = timestamp
			end
		end
	end
end

end

function getCold(player)
	local cold = GetSpellInfo(62188)
	local _, _, icon, stack = UnitDebuff(player, cold)
	return stack
end

function FailBotPro:Wipe()
	SendChatMessage(L["susped"],RAID,nil,nil)
	FailBotPro:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
	FailBotPro:ScheduleTimer("ResumeFailReporting", self.Resume, 60)
end

function FailBotPro:Resume()
	SendChatMessage(L["resume"],RAID,nil,nil)
	addon:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED", "CombatLog")	
end

function FailBotPro:AddFail(p,s,spellId)
	FailBotPro:Initialize()
	if OFailCount[p] == nil then
		OFailCount[p] = 1
		FailCount[p] = 1
	else
		if FailCount[p] == nil then
			FailCount[p] = 1
		else
			OFailCount[p] = OFailCount[p] + 1
			FailCount[p] = FailCount[p] + 1
		end
	end
	if ((s==L["shaman_healing"]) or (s==L["moving"])) then
		FailBotPro:SendChatMessage(p,s..FailBotPro:GetSpellLocalizedName(spellId))
	else
		FailBotPro:SendChatMessage(p,s)
	end
end

function FailBotPro:RemoveFail(p,t,w)
	if OFailCount[p] ~= nil then
		OFailCount[p] = OFailCount[p] - 1
		if FailCount[p] ~= nil then
			FailCount[p] = FailCount[p] - 1
		end
	end
	SendChatMessage(L["removed"]..p,t,nil,w)
end	

function FailBotPro:SendChatMessage(p,s)
	FailBotPro:Msg(p..L["fails_at"]..s.." ("..FailCount[p]..")",self.db.profile.announce)
end

function FailBotPro:Msg(m,t)
	local w = self.db.profile.channelnumber
	SendChatMessage(m,t,nil,w)
end

function FailBotPro:reset()
	FailCount = {}
	DEFAULT_CHAT_FRAME:AddMessage(L["reseted"]);
end

function FailBotPro:oreset()
	FailCount = {}
	OFailCount = {}
	DEFAULT_CHAT_FRAME:AddMessage(L["oreseted"]);
end
